<?php
    /**
    *   @title UIUCTF MAC Challenge
    *   @author Nyyck
    *   @date 08/09/13
    *  
    **/

    include( "encryption.php" );

    function replaceChar( $fullC, $pos, $prevVal, $newVal ){
        $iv = substr( $fullC, 0, 32 );
        $ivBin = hex2bin( $iv );
   

        $ivBin ^= hex2bin( ( str_repeat( "0", $pos ) ) . 
                        bin2hex( $prevVal ) . ( str_repeat( "0", ( 32 - $pos - 2 ) ) ) );
        $ivBin ^= hex2bin( ( str_repeat( "0", $pos ) ) . 
                        bin2hex( $newVal ) . ( str_repeat( "0", ( 32 - $pos - 2 ) ) ) );


        return bin2hex( $ivBin );
    }



    $replaceable = $_GET['replaceable'];
    $replaced = replaceChar( $replaceable, 2, "8", "9" ); 

    echo 'Plaintext decrypt: ', decrypt( $replaceable ), "<br /><br />";
    echo "Replaced IV: $replaced<br />";
    echo 'Replaced Ciphertext: ', $replaced . substr($replaceable, 32), "<br />";
    echo "Replaced plaintext: ", decrypt($replaced . substr($replaceable, 32));
?>
