<?php
    /**
    *   @title UIUCTF Challenge
    *   @author Nyyck
    *   @date 08/09/13
    *  
    **/


    $key = pack('H*', "bcb04b7e103a0cd8b54763051cef03bc55abe029fdebae5e1e417e2ffb2a00a3"); 

    // THANKS PHP.NET!!
    function pkcs5_pad ($text, $blocksize) 
    { 
        $pad = $blocksize - (strlen($text) % $blocksize); 
        return $text . str_repeat(chr($pad), $pad); 
    } 

    function pkcs5_unpad($text) 
    { 
        $pad = ord($text{strlen($text)-1}); 
        if ($pad > strlen($text)) return false; 
        if (strspn($text, chr($pad), strlen($text) - $pad) != $pad) return false; 
        return substr($text, 0, -1 * $pad); 
    } 


    function encrypt( $plaintext ){
	global $key;

        $key_size =  strlen($key);

        # create a random IV to use with CBC encoding
        $iv_size = mcrypt_get_iv_size(MCRYPT_RIJNDAEL_128, MCRYPT_MODE_CBC);
        $iv = mcrypt_create_iv($iv_size, MCRYPT_RAND);
        
        $plaintext_utf8 = utf8_encode( pkcs5_pad( $plaintext, 16 ) );
        
        $ciphertext = mcrypt_encrypt(MCRYPT_RIJNDAEL_128, $key,
                                     $plaintext_utf8, MCRYPT_MODE_CBC, $iv);

        $ciphertext = $iv . $ciphertext;
        
        # encode the resulting cipher text so it can be represented by a string
        $ciphertextHex = bin2hex($ciphertext);

        return $ciphertextHex;
    }
    
    function decrypt( $c ){
	global $key;

        $ivSize = mcrypt_get_iv_size(MCRYPT_RIJNDAEL_128, MCRYPT_MODE_CBC);

        $ciphertextBin = hex2bin( $c );
        
        # get the IV
        $iv = substr($ciphertextBin, 0, $ivSize);
        
        # Slice it off
        $ciphertextBin = substr($ciphertextBin, $ivSize);

        # may remove 00h valued characters from end of plain text
        $plaintextUtf8 = mcrypt_decrypt(MCRYPT_RIJNDAEL_128, $key,
                                             $ciphertextBin, MCRYPT_MODE_CBC, $iv);
        
        return pkcs5_unpad( $plaintextUtf8 );
    }

?>
